//'*****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2006                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************/

// -------------------------------------------------------------------
// FVX Sample Program
// C_CAO
//
// 쐬 : R.Nagashima
//
//  : 2006/12/08 
// -------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Threading;
using System.Text;
using System.Windows.Forms;
using System.IO;
// FVXf[^\̎gp錾
using FVDATASLib;

namespace GraySearch
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }
        
        //͈
        FvRectangle m_ExeRegion = new FvRectangle();       
        // rfIfoCXI[vĂ邩
        private bool m_blnVideoOpened = false;
        // rfIݒt@CitpXj
        private string m_strVideoConfFilePath = "";
        // fBNg
        private string m_strDirectory;
      
        private void frmMain_Load(object sender, EventArgs e)
        {
            int IntErr;
            frmSelectVideoConfFile fVideoConf = new frmSelectVideoConfFile();
            frmLicense fLicense = new frmLicense();
           
            // ϐ
            m_blnVideoOpened = false;
            cmdGrab.Enabled = false;

            cmbSearchMode.Items.Insert(0,"ʏ̃p^[");//NORMAL_PATTERN
            cmbSearchMode.Items.Insert(1,"̃p^[");//BLACK_LINE_PATERN
            cmbSearchMode.Items.Insert(2,"̃p^[");
            cmbSearchMode.Items.Insert(3,"sp^[");
            cmbSearchMode.SelectedIndex = 0;

            cmbPrecision.Items.Insert(0, "ʏ퐸x");
            cmbPrecision.Items.Insert(1, "x");
            cmbPrecision.Items.Insert(2, "x");
            cmbPrecision.SelectedIndex = 1;
            
            //ʂ̐
            axFvxDisplayEx1.CreateDisplay();

            //͈͂̏lݒ(摜̑Sʂɐݒj
            m_ExeRegion.xs = -1;
            m_ExeRegion.xe = -1;
            m_ExeRegion.ys = -1;
            m_ExeRegion.ye = -1;

            //ƃfBNgޔ
            m_strDirectory = Directory.GetCurrentDirectory();

            //gp̊mF
            if (fLicense.ShowDialog() == DialogResult.OK)
            {
                //rfIݒt@C̑I
                if (fVideoConf.ShowDialog() == DialogResult.OK)
                    m_strVideoConfFilePath = fVideoConf.strVideoConfFilePath;

                if (fVideoConf.chkNotUseCamera.Checked == false)
                {
                    //rfIݒt@CR|[lgɐݒ
                    axFvxVideo1.VideoConfFile = m_strVideoConfFilePath;

                    //foCXI[v
                    try
                    {
                        axFvxVideo1.OpenDevice();
                    }
                    catch (Exception)
                    {
                        axFvxVideo1.GetErrReport(out IntErr);
                        MessageBox.Show("rfIfoCX̃I[vɎs܂ ErrCode= " + IntErr.ToString() + "\r\n摜t@Ĉ݂̗pɂȂ܂B");
                        return;
                    }

                    //VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
                    //̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                    //{vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
                    //g̃Lv`{[hɍ킹ĕύXĂB
                    Thread.Sleep(350);

                    //GrabSync/GrabASync\bhłImegeTCY̕ύXs܂̂ŁA
                    //炩ChangeImageSize\bhɂImagẽTCYύXĂ
                    //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
                    axFvxVideo1.ChangeImageSize(axFvxImage1.GetOcx());
                    try
                    {
                        // 捞
                        axFvxVideo1.GrabSync(axFvxImage1.GetOcx());
                    }
                    catch (Exception)
                    {
                        axFvxVideo1.GetErrReport(out IntErr);
                        MessageBox.Show("rfI̎捞Ɏs܂ ErrCode= " + IntErr.ToString() + "\r\n摜t@Ĉ݂̗pɂȂ܂B");
                        return;
                    }

                    //rfIfoCX̏Ԃۑ
                    m_blnVideoOpened = true;
                    cmdGrab.Enabled = true;

                    //摜\
                    axFvxDisplayEx1.DrawImage(axFvxImage1.GetOcx());
                }
            }
            else
            {
                //I
                Application.Exit();
                return;
            }
     }

        // I
        private void frmMain_Closed(object sender, FormClosedEventArgs e)
        {
            if (m_blnVideoOpened)
            {
                // rfIfoCXI[vĂꍇ̓N[Y܂
                axFvxVideo1.CloseDevice();
            }
        }

        // EBhETCYύXꂽƂ̏
        private void frmMain_Resize(object sender, EventArgs e)
        {
            Size NewSize = new Size();
            NewSize.Width = this.Size.Width - 230;
            NewSize.Height = this.Size.Height - 150;
            axFvxDisplayEx1.Size = NewSize;
        }

        // J荞
        private void cmdGrab_Click(object sender, EventArgs e)
        {
            //摜t@Cǂݍ݂ɂāA摜TCY
            //ύXĂ\邽߁AChangeImageSizes܂B
            //摜TCYύX\ꍇ́AɈxsΖL܂B
            axFvxVideo1.ChangeImageSize(axFvxImage1.GetOcx());

            try
            {
                //捞
                axFvxVideo1.GrabSync(axFvxImage1.GetOcx());
            }
            catch (Exception)
            {
                int IntErr;
                axFvxVideo1.GetErrReport(out IntErr);
                MessageBox.Show("rfI̎捞Ɏs܂ ErrCode= " + IntErr.ToString());
            }

            //荞񂾉摜ʂɕ\
            axFvxDisplayEx1.DrawImage(axFvxImage1.GetOcx());
        }
        
        //摜t@CǍ
        private void cmdLoadImage_Click(object sender, EventArgs e)
        {
            // _CAOɂĉ摜t@CI܂
            openFileDialog1.InitialDirectory = m_strDirectory;
            openFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp";
            openFileDialog1.DefaultExt = "*.bmp";
            openFileDialog1.ShowDialog();

            if (openFileDialog1.FileName.Length > 0)
            {
                //FileAccessR|[lgpāA
                //t@CImageɉ摜ǂݍ݂܂
                axFvxFileAccess1.FilePath = openFileDialog1.FileName;

                try
                {
                    axFvxFileAccess1.LoadBitmap(axFvxImage1.GetOcx());
                }
                catch (Exception)
                {
                    int IntErr = 0;
                    axFvxFileAccess1.GetErrReport(out IntErr);
                    MessageBox.Show("Ǎ݂Ɏs܂ ErrCode= " + IntErr.ToString());
                    return;
                }

                //摜^Cv`FbN
                if ((axFvxImage1.BitPerPixel != 8) || (axFvxImage1.ImageType != FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray))
                {
                    MessageBox.Show("8bitOC̉摜ł͂܂");
                    axFvxImage1.BitPerPixel = 8;
                    axFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray;
                    axFvxImage1.ImageWidth = 512;
                    axFvxImage1.ImageHeight = 480;
                }
                axFvxDisplayEx1.DrawImage(axFvxImage1.GetOcx());
            }
        }

        //摜̕ۑ
        private void cmdSaveImage_Click(object sender, EventArgs e)
        {
            saveFileDialog1.InitialDirectory = m_strDirectory;
            saveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp";
            saveFileDialog1.DefaultExt = "*.bmp";
            saveFileDialog1.ShowDialog();

            if (saveFileDialog1.FileName.Length > 0)
            {
                //FileAccessR|[lgg
                //Imaget@Cɕۑ܂
                axFvxFileAccess1.FilePath = saveFileDialog1.FileName;
                try
                {
                    axFvxFileAccess1.SaveBitmap(axFvxImage1.GetOcx());
                }
                catch (Exception)
                {
                    int IntErr = 0;
                    axFvxFileAccess1.GetErrReport(out IntErr);
                    MessageBox.Show("ۑɎs܂B@ErrCode= " + IntErr.ToString());
                    return;
                }
            }
        }

        //s
        private void cmdExecute_Click(object sender, EventArgs e)
        {
            double dblTime = 0.0;
            int IntCount = 0;
            
            //ʎ擾p
            FvSearchResultGroup SearchResultGroup = new FvSearchResultGroup();
            FvPoint Point = new FvPoint();

            //\NA
            axFvxDisplayEx1.ClearOverlay(-1);

            try
            {
                //p[^ݒ
                axFvxCorrelation1.SetInspectArea(m_ExeRegion);
                axFvxCorrelation1.SearchMode = (FVXCOMCORRELATIONLib.SEARCH_MODE_TYPE)cmbSearchMode.SelectedIndex;
                axFvxCorrelation1.Precision = (FVXCOMCORRELATIONLib.PRECISION_TYPE)cmbPrecision.SelectedIndex;

                //摜̏
                int Temp;
                if (int.TryParse(txtCondition.Text,out Temp) == false || Temp < 1 || Temp > 9)
                {
                    MessageBox.Show("摜Ԃ 1`9 ̊ԂŎw肵Ă");
                    return;
                }
                else	axFvxCorrelation1.Condition = Temp;
                   
                //肵l
                if (int.TryParse(txtThreshold.Text,out Temp) == false || Temp < 10 || Temp > 100)
                {
                    MessageBox.Show("臒l 10`100 ̊ԂŎw肵Ă");
                    return;
                }
                else	axFvxCorrelation1.ScoreThresh = Temp;
                    
                //r肵l
                if (int.TryParse(txtMiddleThreshold.Text,out Temp) == false || Temp < 10 || Temp > 100)
                {
                    MessageBox.Show("r臒l 10`100 ̊ԂŎw肵Ă");
                    return;
                }
                else   axFvxCorrelation1.ScoreThresh2 = Temp;
         
                //T[`
				if (int.TryParse(txtSearchNum.Text, out Temp) == false)
				{
					MessageBox.Show("T[`w肵Ă");
					return;
				}	
				else	axFvxCorrelation1.SearchNum = Temp;
				

	        	//͈͐ڐGĂ̂o邩
                if (chkWndTouch.Checked == true)
                    axFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.ON;

                else
                    axFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.OFF;

                // ----------------------------------------------------------------
                // ԌvJn
                axFvxPerformanceCounter1.StartCount();

                // p^[ݒ
                axFvxCorrelation1.SetPattern(axFvxPattern1.GetOcx());
               
                // T[`s
                axFvxCorrelation1.Execute(axFvxImage1.GetOcx(), out IntCount);
                // ----------------------------------------------------------------
                
                //ԌvI
                axFvxPerformanceCounter1.StopCount(out dblTime);

                //͈͂ŕ\
                axFvxDisplayEx1.PenColor = Color.Blue;
                axFvxDisplayEx1.DrawData(0, m_ExeRegion);

                //T[`ʂԂŕ\
                axFvxDisplayEx1.PenColor = Color.Red;
                axFvxDisplayEx1.DrawData(0, SearchResultGroup);

                txtResult.Text = string.Format(" : " + dblTime.ToString("0.0") + "ms\r\nT[` : " + IntCount.ToString("0") + "\r\n  no     score     x     y");

                axFvxCorrelation1.GetResult(0, SearchResultGroup);
                axFvxDisplayEx1.DrawData(0, SearchResultGroup);

                for( int i = 0; i < SearchResultGroup.Count; i++)
                {
                    Point.x = SearchResultGroup.Item2(i).x;
                    Point.y = SearchResultGroup.Item2(i).y;
           
                    axFvxDisplayEx1.DrawText(0, Point, string.Format("{0:0}", i));
                    txtResult.Text = txtResult.Text + string.Format("\r\n  [{0:0}]     {1:0}     {2:0}     {3:0}" , i,SearchResultGroup.Item2(i).score , Point.x, Point.y);
                }
            }

            //COMG[擾
            catch (System.Runtime.InteropServices.COMException) 
            {
                int ErrNum = 0;
                string ErrMsg;
                axFvxCorrelation1.GetErrReport(out ErrNum);

                switch( ErrNum)
                {
                    case 0:
                        ErrMsg = "G[";
                        break;
                    case 5001:
                        ErrMsg = "p^݂Ă܂";
                        break;
                    case 5005:
                        ErrMsg = "p[^Ⴂ܂";
                        break;
                    case 5006:
                        ErrMsg = "^Ⴂ܂";
                        break;
                    case 5007:
                        ErrMsg = "p^摜ׁ̈Ao^ł܂";
                        break;
                    case 5008:
                        ErrMsg = "p^ƃ}XÑTCYv܂";
                        break;
                    case 5009:
                        ErrMsg = "p[^NULLlw肳܂";
                        break;
                    case 5010:
                        ErrMsg = "̊mۂɎs܂";
                        break;
                    case 5022:
                        ErrMsg = "p^w肳Ă܂";
                        break;
                    default:
                        ErrMsg = "sȃG[";
                        break;
                }
                MessageBox.Show(ErrMsg,"error",MessageBoxButtons.OK,MessageBoxIcon.Error);
            }

            //VXeG[擾
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }


        }

        //p^o^
        private void cmdSetPattern_Click(object sender, EventArgs e)
        {
            FvRectangle pRect = new FvRectangle();//p^̈
            FvPoint pPoint = new FvPoint();//p^_

            int IntOK = 0;
            double dblTemp = 0;
            
            // o^̏`ݒ
            pRect.xs = 100;
            pRect.ys = 100;
            pRect.xe = 200;
            pRect.ye = 200;
            axFvxROI2.SetRectangle(pRect);

            //FvxROIgď͈͑I_CAOo܂B
            axFvxROI2.MakeROIDialog(axFvxImage1.GetOcx(), out IntOK);

            if ((IntOK == 1) && (axFvxROI2.CheckRectangle == 1))
            {
                axFvxROI2.GetRectangle(pRect);
                
      			//n_ƏI_tɂȂĂȂ`FbN܂
    			//FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
	    		//tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
                if(pRect.xe < pRect.xs)
                {
                    dblTemp = pRect.xs;
                    pRect.xs = pRect.xe;
                    pRect.xe = dblTemp;
                }
                if(pRect.ye < pRect.ys)
                {
                    dblTemp = pRect.ys;
                    pRect.ys = pRect.ye;
                    pRect.ye = dblTemp;
                }
                   
                if(axFvxROI2.CheckPoint == 1)
                {
                    axFvxROI2.GetPoint(pPoint);
                }
                else{
                    MessageBox.Show("p^[_w肳܂łB\r\np^[`̒S_Ƃēo^܂","p^[o^",MessageBoxButtons.OK,MessageBoxIcon.Error);
                    pPoint.x = (pRect.xs + pRect.xe) / 2;
                    pPoint.y = (pRect.ys + pRect.ye) / 2;
                }
                axFvxPattern1.MakePattern(axFvxImage1.GetOcx(),pRect,pPoint);
            }
        }

        //͈͐ݒ
        private void cmdExeRegion_Click(object sender, EventArgs e)
        {
            int IntOK = 0;
            double dblTemp = 0.0;

            axFvxROI1.SetRectangle(m_ExeRegion);

            // FvxROIgď͈͑I_CAOo܂
            axFvxROI1.UsePoint = false;
            axFvxROI1.MakeROIDialog(axFvxImage1.GetOcx(), out IntOK);

            if ((IntOK == 1) && (axFvxROI1.CheckRectangle == 1))
            {
                axFvxROI1.GetRectangle(m_ExeRegion);
                // n_ƏI_tɂȂĂȂ`FbN܂
                // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
                // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
                if (m_ExeRegion.xe < m_ExeRegion.xs)
                {
                    dblTemp = m_ExeRegion.xs;
                    m_ExeRegion.xs = m_ExeRegion.xe;
                    m_ExeRegion.xe = dblTemp;
                }
                if (m_ExeRegion.ye < m_ExeRegion.ys)
                {
                    dblTemp = m_ExeRegion.ys;
                    m_ExeRegion.ys = m_ExeRegion.ye;
                    m_ExeRegion.ye = dblTemp;
                }
            }
        }

        //p^̓Ǎ
        private void cmdLoadPattern_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = m_strDirectory;
            openFileDialog1.Filter = "pattern file(*.pat)|*.pat";
            openFileDialog1.DefaultExt = "*.pat";
            openFileDialog1.ShowDialog();

            if (openFileDialog1.FileName.Length > 0)
            {
               try{
                    axFvxPattern1.LoadPattrenFileName = openFileDialog1.FileName;
                    axFvxPattern1.Load();
                }
                catch(Exception)
                {
                    int IntErr;
                    axFvxPattern1.GetErrReport( out IntErr);
                    MessageBox.Show("p^[Ǎs  ErrCode = " + IntErr.ToString(), "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }
        }

        //p^̕ۑ
        private void cmdSavePattern_Click(object sender, EventArgs e)
        {
            //p^t@C̊gq͓Ɍ߂Ă܂񂪁A
            //"pat"gp邱Ƃ𐄏܂B
            saveFileDialog1.InitialDirectory = m_strDirectory;
            saveFileDialog1.Filter = "pattern file(*.pat)|*.pat";
            saveFileDialog1.DefaultExt = "*.pat";
            saveFileDialog1.ShowDialog();
            if (saveFileDialog1.FileName.Length > 0)
            {
                try
                {
                    axFvxPattern1.SavePattrenFileName = saveFileDialog1.FileName;
                    axFvxPattern1.Save();
                }
                catch (Exception)
                {
                    int IntErr;
                    axFvxPattern1.GetErrReport(out IntErr);
                    MessageBox.Show("p^[ۑs  ErrCode = " + IntErr.ToString(), "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }

        }

        //p^̕\
        private void cmdDispPattern_Click(object sender, EventArgs e)
        {
            axFvxPattern1.Disp();
        }
        
        //p^̃}XNݒ
        private void cmdSetPatternMask_Click(object sender, EventArgs e)
        {
            axFvxPattern1.DefMask(-1,-1);
        }

        //\NA
        private void cmdDispClear_Click(object sender, EventArgs e)
        {
            axFvxDisplayEx1.ClearOverlay(-1);
        }

        //l̂ݓ͂ł悤
        private void txtCondition_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ((e.KeyChar < '0' || e.KeyChar > '9') && e.KeyChar != '\b')
                e.Handled = true;
        }

        //l̂ݓ͂ł悤
        private void txtThreshold_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ((e.KeyChar < '0' || e.KeyChar > '9') && e.KeyChar != '\b')
                e.Handled = true;

        }

        //l̂ݓ͂ł悤
        private void txtMiddleThreshold_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ((e.KeyChar < '0' || e.KeyChar > '9') && e.KeyChar != '\b')
                e.Handled = true;

        }

        //l̂ݓ͂ł悤
        private void txtSearchNum_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ((e.KeyChar < '0' || e.KeyChar > '9') && e.KeyChar != '\b')
                e.Handled = true;
		}
     }
}